diff -urN punbb-1.4.2/admin/db_update.php punbb-1.4.3/admin/db_update.php
--- punbb-1.4.2/admin/db_update.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/admin/db_update.php	2015-06-15 09:21:05.000000000 -0400
@@ -10,7 +10,7 @@
  */
 
 
-define('UPDATE_TO', '1.4.2');
+define('UPDATE_TO', '1.4.3');
 define('UPDATE_TO_DB_REVISION', 5);
 
 // The number of items to process per pageview (lower this if the update script times out during UTF-8 conversion)
@@ -26,6 +26,8 @@
 
 define('FORUM_ROOT', '../');
 
+require FORUM_ROOT.'include/constants.php';
+
 // Attempt to load the configuration file config.php
 if (file_exists(FORUM_ROOT.'config.php'))
 	include FORUM_ROOT.'config.php';
@@ -42,12 +44,6 @@
 if (!defined('FORUM_DEBUG'))
 	define('FORUM_DEBUG', 1);
 
-// Define avatars type
-define('FORUM_AVATAR_NONE', 0);
-define('FORUM_AVATAR_GIF', 1);
-define('FORUM_AVATAR_JPG', 2);
-define('FORUM_AVATAR_PNG', 3);
-
 // Turn on full PHP error reporting
 error_reporting(E_ALL);
 
diff -urN punbb-1.4.2/admin/extensions.php punbb-1.4.3/admin/extensions.php
--- punbb-1.4.2/admin/extensions.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/admin/extensions.php	2015-06-15 09:21:05.000000000 -0400
@@ -59,6 +59,10 @@
 	$ext_data = xml_to_array($manifest);
 	$errors = validate_manifest($ext_data, $id);
 
+	/*
+	 * TODO
+	 * Errors must be fully specified instead "bad request" message only
+	 */
 	if (!empty($errors))
 		message(isset($_GET['install']) ? $lang_common['Bad request'] : $lang_admin_ext['Hotfix download failed']);
 
@@ -81,7 +85,7 @@
 		$ext_data['extension']['dependencies'] = $ext_data['extension']['dependencies']['dependency'];
 
 	$query = array(
-		'SELECT'	=> 'e.id',
+		'SELECT'	=> 'e.id, e.version',
 		'FROM'		=> 'extensions AS e',
 		'WHERE'		=> 'e.disabled=0'
 	);
@@ -91,12 +95,21 @@
 
 	$installed_ext = array();
 	while ($row = $forum_db->fetch_assoc($result))
-		$installed_ext[] = $row['id'];
+		$installed_ext[$row['id']] = $row;
 
 	foreach ($ext_data['extension']['dependencies'] as $dependency)
 	{
-		if (!in_array($dependency, $installed_ext))
-			message(sprintf($lang_admin_ext['Missing dependency'], $dependency));
+
+		$ext_dependancy_id = is_array($dependency) ? $dependency['content'] : $dependency;
+		
+	    if (!array_key_exists($ext_dependancy_id, $installed_ext))
+	    {
+		   $errors[] = sprintf($lang_admin_ext['Missing dependency'], $ext_dependancy_id);
+	    }
+	    else if (is_array($dependency) AND isset($dependency['attributes']['minversion']) AND version_compare($dependency['attributes']['minversion'], $installed_ext[$ext_dependancy_id]['version']) > 0)
+	    {
+	    	$errors[] = sprintf($lang_admin_ext['Version dependency error'], $dependency['content'], $dependency['attributes']['minversion']);
+	    }
 	}
 
 	// Setup breadcrumbs
@@ -108,7 +121,7 @@
 		(strpos($id, 'hotfix_') === 0) ? $lang_admin_ext['Install hotfix'] : $lang_admin_ext['Install extension']
 	);
 
-	if (isset($_POST['install_comply']))
+	if (isset($_POST['install_comply']) AND empty($errors))
 	{
 		($hook = get_hook('aex_install_comply_form_submitted')) ? eval($hook) : null;
 
@@ -310,6 +323,27 @@
 		<h2 class="hn"><span><?php echo end($forum_page['crumbs']) ?> "<?php echo forum_htmlencode($ext_data['extension']['title']) ?>"</span></h2>
 	</div>
 	<div class="main-content main-frm">
+<?php
+
+    // If there were any errors, show them
+    if (!empty($errors))
+    {
+        $forum_page['errors'] = array();
+        foreach ($errors as $cur_error)
+            $forum_page['errors'][] = '<li class="warn"><span>'.$cur_error.'</span></li>';
+
+            ($hook = get_hook('aex_install_ext_pre_errors')) ? eval($hook) : null;
+
+?>
+		<div class="ct-box error-box">
+			<h2 class="warn hn"><?php echo $lang_admin_ext['Install ext errors'] ?></h2>
+			<ul class="error-list">
+				<?php echo implode("\n\t\t\t\t", $forum_page['errors'])."\n" ?>
+			</ul>
+		</div>
+<?php
+    }
+?>	
 		<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo $base_url.'/admin/extensions.php'.(isset($_GET['install']) ? '?install=' : '?install_hotfix=').$id ?>">
 			<div class="hidden">
 				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token($base_url.'/admin/extensions.php'.(isset($_GET['install']) ? '?install=' : '?install_hotfix=').$id) ?>" />
@@ -860,7 +894,7 @@
 	if ($forum_config['o_check_for_versions'] == 1)
 	{
 		// Check for the new versions of the extensions istalled
-		$repository_urls = array('http://punbb.informer.com/extensions/1.4');
+		$repository_urls = array(FORUM_PUN_EXTENSION_REPOSITORY_URL);
 		($hook = get_hook('aex_add_extensions_repository')) ? eval($hook) : null;
 
 		$repository_url_by_extension = array();
@@ -881,7 +915,7 @@
 		$update_hour = (isset($forum_ext_versions_update_cache) && (time() - $forum_ext_versions_update_cache > 60 * 60));
 
 		// Update last versions if there is no cahe or some extension was added/removed or one day has gone since last update
-		$update_new_versions_cache = !defined('FORUM_EXT_VERSIONS_LOADED') || (isset($forum_ext_last_versions) && array_diff($inst_exts, $forum_ext_last_versions) != array()) || $update_hour || ($update_hour && isset($min_timestamp) && (time() - $min_timestamp > 60*60*24));
+		$update_new_versions_cache = !defined('FORUM_EXT_VERSIONS_LOADED') || (isset($forum_ext_last_versions) && array_diff(array_keys($inst_exts), array_keys($forum_ext_last_versions)) != array()) || $update_hour || ($update_hour && isset($min_timestamp) && (time() - $min_timestamp > 60*60*24));
 
 		($hook = get_hook('aex_before_update_checking')) ? eval($hook) : null;
 
diff -urN punbb-1.4.2/admin/install.php punbb-1.4.3/admin/install.php
--- punbb-1.4.2/admin/install.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/admin/install.php	2015-06-15 09:21:05.000000000 -0400
@@ -10,8 +10,6 @@
  */
 
 
-define('FORUM_VERSION', '1.4.2');
-define('FORUM_DB_REVISION', 5);
 define('MIN_PHP_VERSION', '5.0.0');
 define('MIN_MYSQL_VERSION', '4.1.2');
 
@@ -19,9 +17,6 @@
 define('FORUM', 1);
 define('FORUM_DEBUG', 1);
 
-define('FORUM_SEARCH_MIN_WORD', 3);
-define('FORUM_SEARCH_MAX_WORD', 20);
-
 if (file_exists(FORUM_ROOT.'config.php'))
 	exit('The file \'config.php\' already exists which would mean that PunBB is already installed. You should go <a href="'.FORUM_ROOT.'index.php">here</a> instead.');
 
@@ -36,6 +31,7 @@
 // Turn off PHP time limit
 @set_time_limit(0);
 
+require FORUM_ROOT.'include/constants.php';
 // We need some stuff from functions.php
 require FORUM_ROOT.'include/functions.php';
 
diff -urN punbb-1.4.2/admin/prune.php punbb-1.4.3/admin/prune.php
--- punbb-1.4.2/admin/prune.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/admin/prune.php	2015-06-15 09:21:05.000000000 -0400
@@ -242,6 +242,8 @@
 	$cur_category = 0;
 	while ($forum = $forum_db->fetch_assoc($result))
 	{
+		($hook = get_hook('apr_pre_prune_forum_loop_start')) ? eval($hook) : null;
+		
 		if ($forum['cid'] != $cur_category)	// Are we still in the same category?
 		{
 			if ($cur_category)
@@ -252,6 +254,8 @@
 		}
 
 		echo "\t\t\t\t\t\t\t\t\t".'<option value="'.$forum['fid'].'">'.forum_htmlencode($forum['forum_name']).'</option>'."\n";
+		
+		($hook = get_hook('apr_pre_prune_forum_loop_end')) ? eval($hook) : null;
 	}
 
 ?>
diff -urN punbb-1.4.2/edit.php punbb-1.4.3/edit.php
--- punbb-1.4.2/edit.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/edit.php	2015-06-15 09:21:05.000000000 -0400
@@ -89,8 +89,8 @@
 
 		if ($subject == '')
 			$errors[] = $lang_post['No subject'];
-		else if (utf8_strlen($subject) > 70)
-			$errors[] = $lang_post['Too long subject'];
+		else if (utf8_strlen($subject) > FORUM_SUBJECT_MAXIMUM_LENGTH)
+			$errors[] = sprintf($lang_post['Too long subject'], FORUM_SUBJECT_MAXIMUM_LENGTH);
 		else if ($forum_config['p_subject_all_caps'] == '0' && check_is_all_caps($subject) && !$forum_page['is_admmod'])
 			$subject = utf8_ucwords(utf8_strtolower($subject));
 	}
@@ -297,7 +297,7 @@
 <?php if ($can_edit_subject): ?>				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
 					<div class="sf-box text required">
 						<label for="fld<?php echo ++ $forum_page['fld_count'] ?>"><span><?php echo $lang_post['Topic subject'] ?></span></label><br />
-						<span class="fld-input"><input id="fld<?php echo $forum_page['fld_count'] ?>" type="text" name="req_subject" size="70" maxlength="70" value="<?php echo forum_htmlencode(isset($_POST['req_subject']) ? $_POST['req_subject'] : $cur_post['subject']) ?>" required /></span>
+						<span class="fld-input"><input id="fld<?php echo $forum_page['fld_count'] ?>" type="text" name="req_subject" size="<?php echo FORUM_SUBJECT_MAXIMUM_LENGTH ?>" maxlength="<?php echo FORUM_SUBJECT_MAXIMUM_LENGTH ?>" value="<?php echo forum_htmlencode(isset($_POST['req_subject']) ? $_POST['req_subject'] : $cur_post['subject']) ?>" required /></span>
 					</div>
 				</div>
 <?php endif; ($hook = get_hook('ed_pre_message_box')) ? eval($hook) : null; ?>				<div class="txt-set set<?php echo ++$forum_page['item_count'] ?>">
diff -urN punbb-1.4.2/header.php punbb-1.4.3/header.php
--- punbb-1.4.2/header.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/header.php	2015-06-15 09:21:05.000000000 -0400
@@ -105,8 +105,13 @@
 if (!empty($forum_page['nav']))
 	$forum_head['nav'] = implode("\n", $forum_page['nav']);
 
-$forum_head['search'] = '<link rel="search" href="'.forum_link($forum_url['search']).'" title="'.$lang_common['Search'].'" />';
-$forum_head['author'] = '<link rel="author" href="'.forum_link($forum_url['users']).'" title="'.$lang_common['User list'].'" />';
+if ($forum_user['g_read_board'] == '1' && $forum_user['g_search'] == '1')
+{
+	$forum_head['search'] = '<link rel="search" type="text/html" href="'.forum_link($forum_url['search']).'" title="'.$lang_common['Search'].'" />';
+	$forum_head['opensearch'] = '<link rel="search" type="application/opensearchdescription+xml" href="'.forum_link($forum_url['opensearch']).'" title="'.forum_htmlencode($forum_config['o_board_title']).'" />';
+}
+
+$forum_head['author'] = '<link rel="author" type="text/html" href="'.forum_link($forum_url['users']).'" title="'.$lang_common['User list'].'" />';
 
 ob_start();
 
diff -urN punbb-1.4.2/include/cache.php punbb-1.4.3/include/cache.php
--- punbb-1.4.2/include/cache.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/include/cache.php	2015-06-15 09:21:05.000000000 -0400
@@ -351,6 +351,8 @@
 			$redirect_tag = ($cur_forum['redirect_url'] != '') ? ' &gt;&gt;&gt;' : '';
 			$output .= "\t\t\t\t".'<option value="'.$cur_forum['fid'].'"<?php echo ($forum_id == '.$cur_forum['fid'].') ? \' selected="selected"\' : \'\' ?>>'.forum_htmlencode($cur_forum['forum_name']).$redirect_tag.'</option>'."\n";
 			$forum_count++;
+			
+			($hook = get_hook('ch_fn_generate_quickjump_cache_forum_loop_end')) ? eval($hook) : null;
 		}
 
 		$output .= "\t\t\t".'</optgroup>'."\n\t\t".'</select>'."\n\t\t".'<input type="submit" id="qjump-submit" value="<?php echo $lang_common[\'Go\'] ?>" /></span>'."\n\t".'</div>'."\n".'</form>'."\n";
@@ -566,6 +568,11 @@
 		{
 			foreach ($inst_exts as $ext)
 			{
+			    
+			    if ((0 === strpos($ext['id'], 'pun_') AND FORUM_PUN_EXTENSION_REPOSITORY_URL != $url) OR
+			            ((FALSE === strpos($ext['id'], 'pun_') AND !isset($ext['repo_url'])) OR (isset($ext['repo_url']) AND $ext['repo_url'] != $url)))
+			        continue;
+			    			    
 				$remote_file = get_remote_file($url.'/'.$ext['id'].'/lastversion', 2);
 				$version = empty($remote_file['content']) ? '' : forum_trim($remote_file['content']);
 				unset($remote_file);
diff -urN punbb-1.4.2/include/common_admin.php punbb-1.4.3/include/common_admin.php
--- punbb-1.4.2/include/common_admin.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/include/common_admin.php	2015-06-15 09:21:05.000000000 -0400
@@ -216,10 +216,13 @@
 
 	if (is_array($name) && count($name) > 0)
 	{
-		function clean_conf_names($n)
+		if (!function_exists('clean_conf_names'))
 		{
-			global $forum_db;
-			return '\''.$forum_db->escape($n).'\'';
+			function clean_conf_names($n)
+			{
+				global $forum_db;
+				return '\''.$forum_db->escape($n).'\'';
+			}
 		}
 
 		$name = array_map('clean_conf_names', $name);
diff -urN punbb-1.4.2/include/constants.php punbb-1.4.3/include/constants.php
--- punbb-1.4.2/include/constants.php	1969-12-31 19:00:00.000000000 -0500
+++ punbb-1.4.3/include/constants.php	2015-06-15 09:21:05.000000000 -0400
@@ -0,0 +1,24 @@
+<?php
+
+// Define the version and database revision that this code was written for
+define('FORUM_VERSION', '1.4.3');
+define('FORUM_DB_REVISION', 5);
+
+// Define a few commonly used constants
+define('FORUM_UNVERIFIED', 0);
+define('FORUM_ADMIN', 1);
+define('FORUM_GUEST', 2);
+
+// Define avatars type
+define('FORUM_AVATAR_NONE', 0);
+define('FORUM_AVATAR_GIF', 1);
+define('FORUM_AVATAR_JPG', 2);
+define('FORUM_AVATAR_PNG', 3);
+
+define('FORUM_SUBJECT_MAXIMUM_LENGTH', 70);
+define('FORUM_DATABASE_QUERY_MAXIMUM_LENGTH', 140000);
+
+define('FORUM_SEARCH_MIN_WORD', 3);
+define('FORUM_SEARCH_MAX_WORD', 20);
+
+define('FORUM_PUN_EXTENSION_REPOSITORY_URL', 'http://punbb.informer.com/extensions/1.4');
\ No newline at end of file
diff -urN punbb-1.4.2/include/dblayer/mysqli_innodb.php punbb-1.4.3/include/dblayer/mysqli_innodb.php
--- punbb-1.4.2/include/dblayer/mysqli_innodb.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/include/dblayer/mysqli_innodb.php	2015-06-15 09:21:05.000000000 -0400
@@ -76,7 +76,7 @@
 
 	function query($sql, $unbuffered = false)
 	{
-		if (strlen($sql) > 140000)
+		if (strlen($sql) > FORUM_DATABASE_QUERY_MAXIMUM_LENGTH)
 			exit('Insane query. Aborting.');
 
 		if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
diff -urN punbb-1.4.2/include/dblayer/mysql_innodb.php punbb-1.4.3/include/dblayer/mysql_innodb.php
--- punbb-1.4.2/include/dblayer/mysql_innodb.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/include/dblayer/mysql_innodb.php	2015-06-15 09:21:05.000000000 -0400
@@ -77,7 +77,7 @@
 
 	function query($sql, $unbuffered = false)
 	{
-		if (strlen($sql) > 140000)
+		if (strlen($sql) > FORUM_DATABASE_QUERY_MAXIMUM_LENGTH)
 			exit('Insane query. Aborting.');
 
 		if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
diff -urN punbb-1.4.2/include/dblayer/mysqli.php punbb-1.4.3/include/dblayer/mysqli.php
--- punbb-1.4.2/include/dblayer/mysqli.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/include/dblayer/mysqli.php	2015-06-15 09:21:05.000000000 -0400
@@ -65,7 +65,7 @@
 
 	function query($sql, $unbuffered = false)
 	{
-		if (strlen($sql) > 140000)
+		if (strlen($sql) > FORUM_DATABASE_QUERY_MAXIMUM_LENGTH)
 			exit('Insane query. Aborting.');
 
 		if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
diff -urN punbb-1.4.2/include/dblayer/mysql.php punbb-1.4.3/include/dblayer/mysql.php
--- punbb-1.4.2/include/dblayer/mysql.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/include/dblayer/mysql.php	2015-06-15 09:21:05.000000000 -0400
@@ -66,7 +66,7 @@
 
 	function query($sql, $unbuffered = false)
 	{
-		if (strlen($sql) > 140000)
+		if (strlen($sql) > FORUM_DATABASE_QUERY_MAXIMUM_LENGTH)
 			exit('Insane query. Aborting.');
 
 		if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
diff -urN punbb-1.4.2/include/dblayer/pgsql.php punbb-1.4.3/include/dblayer/pgsql.php
--- punbb-1.4.2/include/dblayer/pgsql.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/include/dblayer/pgsql.php	2015-06-15 09:21:05.000000000 -0400
@@ -101,7 +101,7 @@
 
 	function query($sql, $unbuffered = false)	// $unbuffered is ignored since there is no pgsql_unbuffered_query()
 	{
-		if (strlen($sql) > 140000)
+		if (strlen($sql) > FORUM_DATABASE_QUERY_MAXIMUM_LENGTH)
 			exit('Insane query. Aborting.');
 
 		if (strrpos($sql, 'LIMIT') !== false)
diff -urN punbb-1.4.2/include/dblayer/sqlite3.php punbb-1.4.3/include/dblayer/sqlite3.php
--- punbb-1.4.2/include/dblayer/sqlite3.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/include/dblayer/sqlite3.php	2015-06-15 09:21:05.000000000 -0400
@@ -87,7 +87,7 @@
 
 	function query($sql, $unbuffered = false)
 	{
-		if (strlen($sql) > 140000)
+		if (strlen($sql) > FORUM_DATABASE_QUERY_MAXIMUM_LENGTH)
 			exit('Insane query. Aborting.');
 
 		if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
diff -urN punbb-1.4.2/include/dblayer/sqlite.php punbb-1.4.3/include/dblayer/sqlite.php
--- punbb-1.4.2/include/dblayer/sqlite.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/include/dblayer/sqlite.php	2015-06-15 09:21:05.000000000 -0400
@@ -90,7 +90,7 @@
 
 	function query($sql, $unbuffered = false)
 	{
-		if (strlen($sql) > 140000)
+		if (strlen($sql) > FORUM_DATABASE_QUERY_MAXIMUM_LENGTH)
 			exit('Insane query. Aborting.');
 
 		if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
diff -urN punbb-1.4.2/include/essentials.php punbb-1.4.3/include/essentials.php
--- punbb-1.4.2/include/essentials.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/include/essentials.php	2015-06-15 09:21:05.000000000 -0400
@@ -10,9 +10,12 @@
 if (!defined('FORUM_ROOT'))
 	exit('The constant FORUM_ROOT must be defined and point to a valid PunBB installation root directory.');
 
-// Define the version and database revision that this code was written for
-define('FORUM_VERSION', '1.4.2');
-define('FORUM_DB_REVISION', 5);
+if (isset($_SERVER['HTTP_X_REQUESTED_WITH']) AND strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest')
+{
+	define('FORUM_REQUEST_AJAX', 1);
+}
+
+require FORUM_ROOT.'include/constants.php';
 
 // Record the start time (will be used to calculate the generation time for the page)
 list($usec, $sec) = explode(' ', microtime());
@@ -98,8 +101,8 @@
 	require FORUM_CACHE_DIR.'cache_config.php';
 }
 
-// Load the Flash messenger class
 require FORUM_ROOT.'include/flash_messenger.php';
+$forum_flash = new FlashMessenger();
 
 // If the request_uri is invalid try fix it
 forum_fix_request_uri();
@@ -132,17 +135,6 @@
 	require FORUM_CACHE_DIR.'cache_hooks.php';
 }
 
-// Define a few commonly used constants
-define('FORUM_UNVERIFIED', 0);
-define('FORUM_ADMIN', 1);
-define('FORUM_GUEST', 2);
-
-// Define avatars type
-define('FORUM_AVATAR_NONE', 0);
-define('FORUM_AVATAR_GIF', 1);
-define('FORUM_AVATAR_JPG', 2);
-define('FORUM_AVATAR_PNG', 3);
-
 // A good place to add common functions for your extension
 ($hook = get_hook('es_essentials')) ? eval($hook) : null;
 
diff -urN punbb-1.4.2/include/flash_messenger.php punbb-1.4.3/include/flash_messenger.php
--- punbb-1.4.2/include/flash_messenger.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/include/flash_messenger.php	2015-06-15 09:21:05.000000000 -0400
@@ -10,15 +10,13 @@
 
 class FlashMessenger
 {
-	const TEMPLATE_MSG_BLOCK = '%s';
-	const TEMPLATE_MSG = '<span class="%s">%s</span>';
+	const TEMPLATE_MSG_BLOCK 	= '%s';
+	const TEMPLATE_MSG 			= '<span class="%s">%s</span>';
 
-	//
-	const MSG_TYPE_ERROR = 'message_error';
-	const MSG_TYPE_WARNING = 'message_warning';
-	const MSG_TYPE_INFO = 'message_info';
+	const MSG_TYPE_ERROR 		= 'message_error';
+	const MSG_TYPE_WARNING 		= 'message_warning';
+	const MSG_TYPE_INFO 		= 'message_info';
 
-	//
 	private $message;
 
 
@@ -26,7 +24,6 @@
 	{
 		global $forum_config;
 
-		// Do not use with redirect
 		$disabled = isset($forum_config['o_redirect_delay']) && intval($forum_config['o_redirect_delay'], 10) > 0;
 
 		if (!$disabled)
@@ -37,29 +34,21 @@
 		$this->message = $this->get_message();
 	}
 
-
-	// Add error message
 	public function add_error($msg)
 	{
 		$this->add_message($msg, self::MSG_TYPE_ERROR);
 	}
 
-
-	// Add warning message
 	public function add_warning($msg)
 	{
 		$this->add_message($msg, self::MSG_TYPE_WARNING);
 	}
 
-
-	// Add info message
 	public function add_info($msg)
 	{
 		$this->add_message($msg, self::MSG_TYPE_INFO);
 	}
 
-
-	//
 	public function show($just_return = false)
 	{
 		if (empty($this->message))
@@ -78,29 +67,24 @@
 		$this->clear();
 	}
 
-
-	//
-	private function clear()
+	public function clear()
 	{
 		$this->message = NULL;
 		$this->save_message();
 	}
 
 
-	//
 	private function add_message($message, $type)
 	{
 		$this->message = array($message, $type);
 		$this->save_message();
 	}
 
-
 	private function save_message()
 	{
 		$_SESSION['punbb_forum_flash'] = serialize($this->message);
 	}
 
-
 	private function get_message()
 	{
 		$message = NULL;
@@ -120,6 +104,3 @@
 		return $message;
 	}
 }
-
-// Create the flash messenger adapter object
-$forum_flash = new FlashMessenger();
diff -urN punbb-1.4.2/include/functions.php punbb-1.4.3/include/functions.php
--- punbb-1.4.2/include/functions.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/include/functions.php	2015-06-15 09:21:05.000000000 -0400
@@ -53,14 +53,18 @@
 	else if (isset($_GET['PHPSESSID']))
 		$forum_session_id = $_GET['PHPSESSID'];
 
-	if (empty($forum_session_id) || !preg_match('/^[a-z0-9]{16,32}$/', $forum_session_id))
+	if (empty($forum_session_id) || !preg_match('/^[a-z0-9\-,]{16,32}$/i', $forum_session_id))
 	{
 		// Create new session id
 		$forum_session_id = random_key(32, FALSE, TRUE);
 		session_id($forum_session_id);
 	}
-
-	session_start();
+	
+	if (!isset($_SESSION))
+	{
+		session_start();
+	}
+	
 	if (!isset($_SESSION['initiated']))
 	{
 		session_regenerate_id();
@@ -1448,7 +1452,7 @@
 				);
 
 				$current_url = get_current_url(255);
-				if ($current_url != null)
+				if ($current_url != null && !defined('FORUM_REQUEST_AJAX'))
 					$query['SET'] .= ', prev_url=\''.$forum_db->escape($current_url).'\'';
 
 				if ($forum_user['idle'] == '1')
@@ -2948,6 +2952,32 @@
 	if ($return != null)
 		return;
 
+	if (defined('FORUM_REQUEST_AJAX'))
+	{
+		$json_data = array(
+				'code'			=>	-3,
+				'message'		=>	$lang_common['CSRF token mismatch'],
+				'csrf_token'	=>	generate_form_token(get_current_url()),
+				'prev_url'		=>	forum_htmlencode($forum_user['prev_url']),
+		);
+
+		foreach ($_POST as $submitted_key => $submitted_val)
+		{
+			if ($submitted_key != 'csrf_token' && $submitted_key != 'prev_url')
+			{
+				$hidden_fields = _csrf_confirm_form($submitted_key, $submitted_val);
+				foreach ($hidden_fields as $field_key => $field_val)
+				{
+					$json_data['post_data'][$field_key] = forum_htmlencode($field_val);
+				}
+			}
+		}
+
+		($hook = get_hook('fn_redirect_pre_send_json')) ? eval($hook) : null;
+		
+		send_json($json_data);
+	}	
+	
 	// Setup breadcrumbs
 	$forum_page['crumbs'] = array(
 		array($forum_config['o_board_title'], forum_link($forum_url['index'])),
@@ -3016,6 +3046,18 @@
 	global $forum_db, $forum_url, $lang_common, $forum_config, $base_url, $forum_start, $tpl_main, $forum_user, $forum_page, $forum_updates, $forum_loader, $forum_flash;
 
 	($hook = get_hook('fn_message_start')) ? eval($hook) : null;
+	
+	if (defined('FORUM_REQUEST_AJAX'))
+	{
+		$json_data = array(
+			'code'		=> -1,
+			'message'	=> $message
+		);
+
+		($hook = get_hook('fn_message_pre_send_json')) ? eval($hook) : null;
+		
+		send_json($json_data);
+	}
 
 	if (!defined('FORUM_HEADER'))
 	{
@@ -3176,6 +3218,19 @@
 	// Do a little spring cleaning
 	$destination_url = preg_replace('/([\r\n])|(%0[ad])|(;[\s]*data[\s]*:)/i', '', $destination_url);
 
+	if (defined('FORUM_REQUEST_AJAX'))
+	{
+		$json_data = array(
+			'code'		=> -2,
+			'message'	=> $message,
+			'destination_url' => $destination_url
+		);
+	
+		($hook = get_hook('fn_redirect_pre_send_json')) ? eval($hook) : null;
+		
+		send_json($json_data);
+	}	
+	
 	// If the delay is 0 seconds, we might as well skip the redirect all together
 	if ($forum_config['o_redirect_delay'] == '0')
 		header('Location: '.str_replace('&amp;', '&', $destination_url));
@@ -3406,3 +3461,51 @@
 
 	exit;
 }
+
+function send_json($params)
+{
+	header('Content-type: application/json; charset=utf-8');
+	if (!function_exists('json_encode'))
+	{
+		function json_encode($data)
+		{
+			switch ($type = gettype($data))
+			{
+				case 'NULL':
+					return 'null';
+				case 'boolean':
+					return ($data ? 'true' : 'false');
+				case 'integer':
+				case 'double':
+				case 'float':
+					return $data;
+				case 'string':
+					return '"' . addslashes($data) . '"';
+				case 'object':
+					$data = get_object_vars($data);
+				case 'array':
+					$output_index_count = 0;
+					$output_indexed = array();
+					$output_assoc = array();
+					foreach ($data as $key => $value)
+					{
+						$output_indexed[] = json_encode($value);
+						$output_assoc[] = json_encode($key) . ':' . json_encode($value);
+						if ($output_index_count !== NULL && $output_index_count++ !== $key)
+						{
+							$output_index_count = NULL;
+						}
+					}
+					if ($output_index_count !== NULL) {
+						return '[' . implode(',', $output_indexed) . ']';
+					} else {
+						return '{' . implode(',', $output_assoc) . '}';
+					}
+				default:
+					return ''; // Not supported
+			}
+		}
+	}
+	echo json_encode($params);
+	die;
+}
diff -urN punbb-1.4.2/include/parser.php punbb-1.4.3/include/parser.php
--- punbb-1.4.2/include/parser.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/include/parser.php	2015-06-15 09:21:05.000000000 -0400
@@ -664,6 +664,23 @@
 
 
 //
+// Callback for handle_url_tag
+//
+function callback_handle_url_nobb($reg)
+{
+	return handle_url_tag($reg[1], (isset($reg[2]) ? $reg[2] : ''), false);
+}
+
+//
+// Callback for handle_url_tag
+//
+function callback_handle_url_bb($reg)
+{
+	return handle_url_tag($reg[1], (isset($reg[2]) ? $reg[2] : ''), true);
+}
+
+
+//
 // Turns an URL from the [img] tag into an <img> tag or a <a href...> tag
 //
 function handle_img_tag($url, $is_signature = false, $alt = null)
@@ -773,13 +790,12 @@
 		}
 	}
 
-	$pattern[] = '#\[url\]([^\[]*?)\[/url\]#e';
-	$pattern[] = '#\[url=([^\[]+?)\](.*?)\[/url\]#e';
+	$text = preg_replace_callback('#\[url\]([^\[]*?)\[/url\]#', 'callback_handle_url_nobb', $text);
+	$text = preg_replace_callback('#\[url=([^\[]+?)\](.*?)\[/url\]#', 'callback_handle_url_nobb', $text);
+
 	$pattern[] = '#\[email\]([^\[]*?)\[/email\]#';
 	$pattern[] = '#\[email=([^\[]+?)\](.*?)\[/email\]#';
 
-	$replace[] = 'handle_url_tag(\'$1\')';
-	$replace[] = 'handle_url_tag(\'$1\', \'$2\')';
 	$replace[] = '<a href="mailto:$1">$1</a>';
 	$replace[] = '<a href="mailto:$1">$2</a>';
 
diff -urN punbb-1.4.2/include/search_functions.php punbb-1.4.3/include/search_functions.php
--- punbb-1.4.2/include/search_functions.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/include/search_functions.php	2015-06-15 09:21:05.000000000 -0400
@@ -7,10 +7,6 @@
  * @package PunBB
  */
 
-if (!defined('FORUM_SEARCH_MIN_WORD'))
-	define('FORUM_SEARCH_MIN_WORD', 3);
-if (!defined('FORUM_SEARCH_MAX_WORD'))
-	define('FORUM_SEARCH_MAX_WORD', 20);
 
 //
 // Cache the results of a search and redirect the user to the results page
diff -urN punbb-1.4.2/include/url/Default/forum_urls.php punbb-1.4.3/include/url/Default/forum_urls.php
--- punbb-1.4.2/include/url/Default/forum_urls.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/include/url/Default/forum_urls.php	2015-06-15 09:21:05.000000000 -0400
@@ -38,6 +38,7 @@
 	'mark_forum_read'				=>	'misc.php?action=markforumread&amp;fid=$1&amp;csrf_token=$2',
 	'new_topic'						=>	'post.php?fid=$1',
 	'new_reply'						=>	'post.php?tid=$1',
+	'opensearch'					=>	'misc.php?action=opensearch',
 	'post'							=>	'viewtopic.php?pid=$1#p$1',
 	'profile_about'					=>	'profile.php?section=about&amp;id=$1',
 	'profile_identity'				=>	'profile.php?section=identity&amp;id=$1',
diff -urN punbb-1.4.2/include/url/File_based/forum_urls.php punbb-1.4.3/include/url/File_based/forum_urls.php
--- punbb-1.4.2/include/url/File_based/forum_urls.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/include/url/File_based/forum_urls.php	2015-06-15 09:21:05.000000000 -0400
@@ -40,6 +40,7 @@
 	'mark_forum_read'				=>	'mark-forum$1-read-$2.html',
 	'new_topic'						=>	'new-topic$1.html',
 	'new_reply'						=>	'new-reply$1.html',
+	'opensearch'					=>	'misc.php?action=opensearch',
 	'post'							=>	'post$1.html#p$1',
 	'profile_about'					=>	'user$1-about.html',
 	'profile_identity'				=>	'user$1-identity.html',
diff -urN punbb-1.4.2/include/url/File_based_(fancy)/forum_urls.php punbb-1.4.3/include/url/File_based_(fancy)/forum_urls.php
--- punbb-1.4.2/include/url/File_based_(fancy)/forum_urls.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/include/url/File_based_(fancy)/forum_urls.php	2015-06-15 09:21:05.000000000 -0400
@@ -41,6 +41,7 @@
 	'mark_forum_read'				=>	'mark-forum$1-read-$2.html',
 	'new_topic'						=>	'new-topic$1.html',
 	'new_reply'						=>	'new-reply$1.html',
+	'opensearch'					=>	'misc.php?action=opensearch',
 	'post'							=>	'post$1.html#p$1',
 	'profile_about'					=>	'user$1-about.html',
 	'profile_identity'				=>	'user$1-identity.html',
diff -urN punbb-1.4.2/include/url/Folder_based/forum_urls.php punbb-1.4.3/include/url/Folder_based/forum_urls.php
--- punbb-1.4.2/include/url/Folder_based/forum_urls.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/include/url/Folder_based/forum_urls.php	2015-06-15 09:21:05.000000000 -0400
@@ -38,6 +38,7 @@
 	'mark_forum_read'				=>	'mark/forum/$1/read/$2/',
 	'new_topic'						=>	'new/topic/$1/',
 	'new_reply'						=>	'new/reply/$1/',
+	'opensearch'					=>	'misc.php?action=opensearch',
 	'post'							=>	'post/$1/#p$1',
 	'profile_about'					=>	'user/$1/about/',
 	'profile_identity'				=>	'user/$1/identity/',
diff -urN punbb-1.4.2/include/url/Folder_based_(fancy)/forum_urls.php punbb-1.4.3/include/url/Folder_based_(fancy)/forum_urls.php
--- punbb-1.4.2/include/url/Folder_based_(fancy)/forum_urls.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/include/url/Folder_based_(fancy)/forum_urls.php	2015-06-15 09:21:05.000000000 -0400
@@ -39,6 +39,7 @@
 	'mark_forum_read'				=>	'mark/forum/$1/read/$2/',
 	'new_topic'						=>	'new/topic/$1/',
 	'new_reply'						=>	'new/reply/$1/',
+	'opensearch'					=>	'misc.php?action=opensearch',
 	'post'							=>	'post/$1/#p$1',
 	'profile_about'					=>	'user/$1/about/',
 	'profile_identity'				=>	'user/$1/identity/',
diff -urN punbb-1.4.2/lang/English/admin_ext.php punbb-1.4.3/lang/English/admin_ext.php
--- punbb-1.4.2/lang/English/admin_ext.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/lang/English/admin_ext.php	2015-06-15 09:21:05.000000000 -0400
@@ -70,5 +70,7 @@
 'Disable dependency'			=>	'This extension cannot be disabled while "%s" is enabled.',
 'Disabled dependency'			=>	'This extension cannot be enabled while "%s" is disabled.',
 'Download latest version'		=>	'Download latest version',
+'Version dependency error'    =>  'Extension "%s" must be version %s or higher',
+'Install ext errors'            =>  '<strong>Warning!</strong> The following errors must be corrected before extension can be installed:',
 
 );
diff -urN punbb-1.4.2/lang/English/common.php punbb-1.4.3/lang/English/common.php
--- punbb-1.4.2/lang/English/common.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/lang/English/common.php	2015-06-15 09:21:05.000000000 -0400
@@ -169,4 +169,8 @@
 'Forum error db reported'	=> 'Database reported:',
 'Forum error db query'		=> 'Failed query:',
 
+// Menu
+'Menu admin'		=> 'Admin Menu',
+'Menu profile'		=> 'Profile Menu',
+
 );
